/*
 * Copyright (c) 2021-2022 Akitsugu Komiyama
 * under the MIT License
 */

/// <summary>
/// GfB^g
/// </summary>
class TEdit {
    // ݕҏW̑SẴeLXg𓾂
    using PFNGetTotalTextUnicode = HGLOBAL(WINAPI*)(void);
    static PFNGetTotalTextUnicode Hidemaru_GetTotalTextUnicode;
    // ݕҏW̑IeLXg𓾂(PÎ)
    using PFNGetSelectedTextUnicode = HGLOBAL(WINAPI*)(void);
    static PFNGetSelectedTextUnicode Hidemaru_GetSelectedTextUnicode;
    // ݕҏW̃eLXg̃J[\s̃eLXg𓾂
    using PFNGetLineTextUnicode = HGLOBAL(WINAPI*)(int nLineNo);
    static PFNGetLineTextUnicode Hidemaru_GetLineTextUnicode;
    // ݕҏW̃eLXg̃J[\̈ʒu擾B}Ncolumnlineno(ɂ͈قȂ)
    using PFNGetCursorPosUnicode = BOOL(WINAPI*)(int* pnLineNo, int* pnColumn);
    static PFNGetCursorPosUnicode Hidemaru_GetCursorPosUnicode;
    // ݕҏW̃eLXg̃}EẌʒuɑΉJ[\̈ʒu擾B
    using PFNGetCursorPosUnicodeFromMousePos = BOOL(WINAPI*)(POINT* ppt, int* pnLineNo, int* pnColumn);
    static PFNGetCursorPosUnicodeFromMousePos Hidemaru_GetCursorPosUnicodeFromMousePos;
    // L[͂Ȃǂ̗Rŏ𒆒fׂԂ܂B
    using PFNCheckQueueStatus = BOOL(WINAPI*)();
    static PFNCheckQueueStatus Hidemaru_CheckQueueStatus;

public:
    TEdit();
public:
    /// <summary>
    /// ݃ANeBuȕҏWt@CԂBȂ󕶎ԂB
    /// </summary>
    /// <returns>t@CBȂ󕶎B</returns>
    std::wstring getFilePath();

    /// <summary>
    /// }Nupdatecount̒lԂB
    /// </summary>
    /// <returns>updatecount̒lB</returns>
    int getUpdateCount();

    /// <summary>
    /// ݃ANeBuȕҏẄ̃eLXgŜԂB
    /// </summary>
    /// <returns>ҏẄ̃eLXgS</returns>
    std::wstring getTotalText();

    /// <summary>
    /// ݃ANeBuȕҏẄ̃eLXgew̕ƂB
    /// </summary>
    /// <param name = "text">VȃeLXge</param>
    /// <returns>ւ̐</returns>
    bool setTotalText(std::wstring text);

    /// <summary>
    /// ݁APIĂꍇȂI𒆂̃eLXgeԂB
    /// </summary>
    /// <returns>I𒆂̃eLXge</returns>
    std::wstring getSelectedText();

    /// <summary>
    /// ݁APIĂꍇȂI𒆂̃eLXgew̕ƂB
    /// </summary>
    /// <param name = "text">VȃeLXge</param>
    /// <returns>ւ̐</returns>
    bool setSelectedText(std::wstring text);

    /// <summary>
    /// ݁AJ[\s(GfB^I)̃eLXgeԂB
    /// </summary>
    /// <returns>J[\s̃eLXge</returns>
    std::wstring getLineText();
 
    /// <summary>
    /// ݁AJ[\s(GfB^I)̃eLXgew̕ƂB
    /// </summary>
    /// <param name = "text">VȃeLXge</param>
    /// <returns>ւ̐</returns>
    bool setLineText(std::wstring text);

    /// <summary>
    /// L[͂Ȃǂ̗Rŏ𒆒fׂԂB
    /// </summary>
    /// <returns>fׂȂtrueAłȂfalse</returns>
    bool isQueueStatus();

public:
    /// <summary>
    /// getCursorPos()̕Ԃľ^B
    /// </summary>
    class ICursorPos {
        int lineno;
        int column;
    public:
        /// <summary>
        /// UnicodeIɍlLineNoB
        /// </summary>
        /// <returns>UnicodeIɍlsB0sڂ</returns>
        int getLineNo();

        /// <summary>
        /// UnicodeIɍlColumnB
        /// </summary>
        /// <returns>ColumnIɍlB0ڂ</returns>
        int getColumn();

        ICursorPos(int lineno, int column);
    };

    /// <summary>
    /// getMousePos()̕Ԃľ^B
    /// </summary>
    class IMousePos {
        int lineno;
        int column;
        int x;
        int y;
    public:
        /// <summary>
        /// UnicodeIɍlLineNoB
        /// </summary>
        /// <returns>UnicodeIɍlsB0sڂ</returns>
        int getLineNo();

        /// <summary>
        /// UnicodeIɍlColumnB
        /// </summary>
        /// <returns>ColumnIɍlB0ڂ</returns>
        int getColumn();

        
        /// <summary>
        /// uwin32apiGetCursorPosvœxƊ{́B
        /// </summary>
        /// <returns>}EXxW</returns>
        int getX();

        /// <summary>
        /// uwin32apiGetCursorPosvœyƊ{́B
        /// </summary>
        /// <returns>}EXyW</returns>
        int getY();
        IMousePos(int lineno, int column, int x, int y);
    };

    /// <summary>
    /// jR[h̃GfB^IȊZł̃J[\̈ʒuԂB
    /// </summary>
    /// <returns>jR[h̃GfB^IȊZł̃J[\̈ʒu</returns>
    ICursorPos getCursorPos();

    /// <summary>
    /// jR[h̃GfB^IȊZł̃}EẌʒuɑΉJ[\̈ʒuԂB
    /// </summary>
    /// <returns>jR[h̃GfB^IȊZł̃}EẌʒuɑΉJ[\̈ʒu</returns>
    IMousePos getMousePos();
};

